---
title: 'Release 1.0.0-RC1'
description: 'With the Go-Live of a Strolch-based application around the corner, it is time to release Version 1.0.0 of Strolch. To this affect we have now released version 1.0.0-RC1 which can be downloaded on the download page.'
weight: -1
date: 2014-08-20T00:00:00+01:00
LastModifierDisplayName: "Robert von Burg"
LastModifierEmail: "eitch@eitchnet.ch"
---

## Release 1.0.0-RC1
With the Go-Live of a Strolch-based application around the corner, it is time to release Version 1.0.0 of Strolch. To this affect we have now released version 1.0.0-RC1 which can be downloaded on the download page.

-------

## Story
Strolch as a component based software agent has been two years in the making. The concepts in Strolch have been taken from a proprietary planning, scheduling and controlling software agent, which was, and is been, used in industrial automation, logistics and production. Strolch was created to bring the concepts, which were working well for small teams to go-live with large projects in short to medium time-frames to the open source world.

Strolch was completely rewritten using the key concepts of a parameterized object model and a component based agent but remembering which clutches the original implementation had, thus trying to eradicate those without bringing in new ones. It might not be perfect in version 1.0.0, but it is a starting point form which to carry on from.

## Features
Strolch isn't feature complete by a long shot, but it sure has got many features which make it useable in a concrete project, thus making sure it is not vaporware =)

The following is a list of key features, many of which were driven by concrete project requirements:

* Separate containers for models (mandates)
* Parameterized model with full CRUD for Resource and Order objects
* Timed values on Resources to map values by time
* Built-in versioning of model - configurable by Realm
* Transparent runtime modes: TRANSIENT, CACHED, TRANSACTIONAL*
* Service and Command pattern for reusing functionality
* XML File based persistence layer*
* PostgreSQL persistence layer*
* Querying using a fluent API
* Services to import and export a model to XML
* Integrated authentication and authorization to validate user privileges using Privilege
* Ready to use Observer pattern
* (currently) Read-only REST API to access the agent model remotely
* Configurable environments
* Opt-in audit trail (including read access, and the audits themselves)
* Basic components required to communicate with external devices using TCP/IP
* With the light weight implementation, where there are basically no third party libraries required for the normal runtime, Strolch has a minimal foot print which allows it to run on small devices for instance a BeagleBone Black. Using the in-memory mode, it is an easy feat to set up test environments with little to no further requirements than the JVM.

## Future
So what is planned for the future? Although Strolch has quite a few interesting features, it is by no way feature complete. The greatest wish is for Strolch to become a community driven platform, so many new features will arise in the future, but at least one major future feature which will be tackled in the near future and will certainly drive the next major release is a planning and scheduling engine using a Gantt chart to visualize the schedule.

The planning engine will use the timed values on Resources extensively to create a planning engine on which Workflows can be placed and allowing to detect violations and bottlenecks.

An extension of the planning of the scheduling engine will allow more than just placing Workflows on Resources, but actually searching groups of Resources for a time slot of when to place tasks. This will allow to use capacity constraints to plan and schedule workflows using different algorithms, and respecting calendars etc.

Further time will be spent on giving Strolch it's own UI. Currently the idea is to use Google's Polymer to implement the UI, thus creating reusable widgets that can be used in projects.

## Take it for a spin
So, now the important part is for new users to start using Strolch for their own projects. Go ahead, check out the Downloads page for the latest release and then checkout the two tutorial applications to get yourself up to speed!

Don't hesitate to send us feedback or questions, we will be delighted to help you get your Strolch-based application up and running, or provide feedback to your concerns!

## Developers
Robert von Burg
Reto Breitenmoser
Dr. Martin Smock

*Currently Transactional mode is missing concrete implementation for querying for the XML persistence