---
title: 'Strolch Release 1.0.0'
description: 'Finally Version 1.0.0 of Strolch has been released and can be downloaded immediately.'
weight: -5
date: 2015-03-31T00:00:00+01:00
LastModifierDisplayName: "Robert von Burg"
LastModifierEmail: "eitch@eitchnet.ch"
---

## Strolch Release 1.0.0

Finally Version 1.0.0 of Strolch has been released and can be [downloaded](/download) immediately.

-------

Before 1.0.0 could be released, some major changes were decided, all driven by
the first big project using Strolch as its underlying stack. Those changes were
minor, and really major, but should make Strolch better and was important for
the first release.

Here is a list of the most interesting changes:

* Java 8 - Strolch was ported to Java 8. This gives a lot of cool features: The
  stream API, lambdas, the new time API, etc.
* TX refactoring: Strolch transactions are instances of `Closeable` so that they
  are closed using a try-with-resource block in Java7. The change that was
  required was to not auto commit. Now a TX is read-only and one has to set the
  auto commit as the last statement. See [this](https://github.com/strolch-li/strolch/commit/46ccb921dfa94f140cbaa3f459c2e434c913d720) commit for more information.
* Added a `tx.flush()` to allow an implementation to flush part of a transaction,
  this feature is vital to perform parts of a transaction before deciding if the
  TX should be committed.
* Fixed the issue where data store mode `CACHED` performed `TRANSACTIONAL` queries,
  instead of staying in-memory.
* `ParameterSelection.stringListSelection()` uses a `StringMatchMode` instead of
  just `equals()`
* `ParameterSelection.dateRangeSelection()` uses a `DateRange` instead of just
  `equals()`
* Added the `MigrationsHandler` to use to perform code migrations of production
  data bases where data shouldn't go lost.
* And many more...

Strolch 1.1.0 is already in development and can also be downloaded from the
download page. Here you can see the current change list
on [GitHub](https://github.com/strolch-li/strolch/compare/1.0.0...develop). For
instance heavy work has been done to implement privilege management by adding a
REST API. Looking forward to a wonderful next Strolch release.

