---
title: 'Strolch Update'
description: 'Long due update on Strolch development.'
weight: -8
date: 2016-04-09T00:00:00+01:00
LastModifierDisplayName: "Robert von Burg"
LastModifierEmail: "eitch@eitchnet.ch"
---

## Strolch Update

Long due update on Strolch development.

-------

Although we have been rather quiet in the last couple of months, anyone viewing
Strolch's commit log, will see that we certainly didn't halt Strolch
development.

We have been hard at work, using Strolch in projects, which required many new
features and fixes. The commit log shows as of today over 180 commits since the
release tag 1.0.0.

Some of the most exciting changes are:

* REST API to query model, incl. privilege management.
* JSON marshalling of all elements.
* Added `Policies`
* Added persisting of user sessions.
* New JavaScript based UI to view Strolch's model. This is an initial version
  and more UI elements and functions will follow.
* Basic planning engine functionality.

Further new features and changes are:

* Implemented a REST API to the privilege management - Now users can be added,
  changed, etc. via call to the appropriate URL under `../strolch/privilege/*`.
* Implemented a REST API to query the user sessions. Incl. invalidating sessions
  to forcefully logout users.
* Implemented a REST API to query `Audits`.
* Implemented REST API to query `Orders`, `Resources` and `Activities`/`Actions`
* Implemented REST API to update `Resources` and `Orders` from XML
* REST API to authenticate now adds a cookie, so authorization is much simpler.
* Added convenience methods in `Service` and `Command` to easily perform system user
  actions.
* Added audits for login/logout of users.
* Added audits for changes to privilege management.
* PostgreSQL persistence layer now
  uses [HikariCP](https://github.com/brettwooldridge/HikariCP)
  for connection pooling.
* Implemented a performance test project
* Added new Parameters of type `IntegerList`, `FloatList` and `LongList`.
* Added feature to ignore a realm on DB init.
* Implemented core planning functionality.
* Added `strolch_minimal` and `strolch_minimal_rest` projects to easily get started.
* Query API now has built in ordering.
* Added `Policy` to all root elements.
* Added new planning web app project. This is a test application for demoing the
  planning engine functionality of Strolch.
* Adding the persisting and reloading of user sessions, so that a new start of
  Strolch does not logout users.
* Implemented to JSON visitors for all root elements.

So, although we've been rather quiet on the blog and on social media, we have
not been quiet in Strolch's development. We are planning to release version
1.1.0 soon, so stay tuned!


